/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef ROUGHJOINWATCHER_H_
#define ROUGHJOINWATCHER_H_

#include "common/mysql_gate.h"
#include "MultiIndex.h"
#include "CQTerm.h"

class RoughJoinWatcher
{
	/* Catch the rough state of MultiIndex before join and try to
	 * utilize it to update PackPack indices.
	 */
public:
	RoughJoinWatcher( MultiIndex &mind, std::vector<Descriptor> &desc );
	~RoughJoinWatcher();

	void UpdatePackPack( MultiIndex &mind );

private:
	bool CheckIfUpdatePossible( std::vector<Descriptor> &desc );
	void CreateRoughImage( MultiIndex &mind );
	void DimensionImage( RSValue *rs, MultiIndex &mind, int dim, int no_packs );

	bool can_update_p2p;
	int dim1, dim2;
	int attr1, attr2;		// numbers of tables/attributes sent to RSIndex_PP must be
							// properly ordered, which is done in CheckIfUpdatePossible()
	RCTable *t1, *t2;
	bool inequality_join;	// true if >= or <= condition found
	RSValue *rs1;
	RSValue *rs2;
};

#endif /*ROUGHJOINWATCHER_H_*/
