/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#include "DataCache.h"

#ifndef __BH_COMMUNITY__
#include "enterprise/core/RCTableImplEnt.h"
//#include "enterprise/core/RCTableTransEnt.h"
#else
#include "shared/core/RCTableImpl.h"
#endif
#include "core/Transaction.h"
//#include "shared/core/RCTableTrans.h"
#include "shared/core/RCEngine.h"


Transaction::~Transaction()
{
	m_tables.clear();
}

RCTable* Transaction::GetTable(const std::string & table_path, bool locked) 
{
	IBGuard guard(m_tablesMutex);
	RCTablePtr t = m_tables[table_path];
	
	if( t.get() == NULL ) {
		// FIXME no table share (NULL)
		RCTablePtr tb = m_rcengine.GetTableShared(table_path, NULL, locked);
		m_tables[table_path] = tb;
		return tb.get();
	} else {
		return t.get();
	}
}

void Transaction::DropTable(const std::string &table)
{
	IBGuard guard(m_tablesMutex);
	m_tables.erase(table);
}


AttrPack* Transaction::GetAttrPackRO(int table, int column, int dp) 
{
	AttrPack *ret;

	//ret = m_localCache.GetAttrPackRO(table, column, dp);
	//if( ret == NULL )
		return m_globalCache->GetAttrPackRO(table,column,dp);
	//return ret;
}

AttrPack * 
Transaction::GetAttrPackRW(int table,int column, int dp) 
{
	AttrPack *ret;
	ret = m_globalCache->GetAttrPackRW(table,column,dp);	
	return ret;	
}

void Transaction::PutAttrPackRO(int table,int column, int dp, AttrPack *dpp) 
{
	m_globalCache->PutAttrPackRO(table,column,dp,dpp);
}

void Transaction::PutAttrPackRW(int table,int column,int dp, AttrPack *dpp) 
{
	m_globalCache->PutAttrPackRW(table,column,dp,dpp);
}

void Transaction::ReleasePack(int table, int column, int dp) 
{
	//m_localCache.ReleasePack( table, column, dp);
	m_globalCache->ReleasePack( table, column, dp);
}

void Transaction::ReleasePackRow(int table, int pack_row)
{
	//m_localCache.ReleasePackRow(table, pack_row);
	m_globalCache->ReleasePackRow( table, pack_row);
}

void Transaction::Commit()
{
	//DataCache::GlobalDataCache().MoveCache(this->m_localCache);
}
