/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef _ENGINE_QUERYTRANSLATOR_H_
#define _ENGINE_QUERYTRANSLATOR_H_

#include <vector>
#include <string>
#include "BHQuery.h"

#include "core/compilation_tools.h"

namespace na
{

	class QueryTranslator
	{
	public:
		QueryTranslator()				{ current_query = NULL; newengine = true; }
		virtual ~QueryTranslator()		{}

		enum Result { SUCCESS = 1, FAILURE = 0 };

		// Translates the whole query from MySQL.
		// For use in the NEW architecture.
		// 'query' must have been already allocated OUTside this method, here it's only filled in.
		Result	TranslateQuery(SELECT_LEX* selects_list, SELECT_LEX* last_distinct, BHQuery* query);

		void	SetTargetEngine(bool neweng)		{ newengine = neweng; }

	private:
		Result	TranslateSelect(SELECT_LEX* select, BHQuery* query);

		// Translates a tree of Items rooted in 'item' to a tree of BHItems rooted in 'bhitem'.
		// Warning: bhitem is allocated inside this method and must be deallocated outside, in calling function!
		Result	TranslateItem(Item* item, BHItem*& bhitem);

		Result	ItemField	(Item* item, BHItem*& bhitem);
		Result	ItemInt		(Item* item, BHItem*& bhitem);
		Result	ItemFunc	(Item* item, BHItem*& bhitem);

		BHQuery*		current_query;		// during translation, the (sub)query being processed at the moment
		bool			newengine;			// do we compile for new engine?
	};


	/*
	Class will be responsible for resolving names of tables and columns
	to appropriate BH objects (RCTable, RCAttr).
	Stores additional structures required for resolving.
	*/
	//class NameResolver
	//{
	//public:
	//	NameResolver();
	//	virtual ~NameResolver();

	//	TableDescriptor* GetTableDescriptor(const TableDescriptor& td);

	//private:
	//	std::vector<TableDescriptor*> m_tables;
	//};


}
#endif

