/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef TXTDATAFORMAT_H_
#define TXTDATAFORMAT_H_

#include "DataFormat.h"

class TxtDataFormat : public DataFormat
{
public:
	TxtDataFormat();
	virtual bool BinaryAsHex() const { return true; }

	virtual DataExporterAutoPtr CreateDataExporter(uchar delimiter, uchar string_qualifier, std::string nulls_str) const;
	virtual ValueParserAutoPtr 	CreateValueParser() const;

	//! Number of bytes taken by a value when written out,
	//! or number of chars if collation not binary and RC_STRING or RC_VARCHAR
	virtual uint ExtrnalSize(AttributeType attrt, int precision, int scale, DTCollation* col = NULL) const;
	virtual ushort ObjPrefixSizeByteSize(AttributeType attr_type) const;
	virtual bool IsVariableSize(AttributeType attr_type) const;

};

#endif /* TXTDATAFORMAT_H_ */
