/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef __RS_SYSTEM_H
#define __RS_SYSTEM_H

#include "Channel.h"
#include "system/Configuration.h"
#include "core/RSI_Framework.h"
#include "system/ConnectionInfo.h"
#include "system/ib_system.h"

//#define FUNCTIONS_EXECUTION_TIMES

#ifdef FUNCTIONS_EXECUTION_TIMES
class FunctionsExecutionTimes;
extern FunctionsExecutionTimes* fet;
class DPID;
typedef std::set<DPID> LoadedDataPackCounter;
extern LoadedDataPackCounter count_distinct_dp_loads;
extern LoadedDataPackCounter count_distinct_dp_decompressions;
extern uint64 NoBytesReadByDPs;
extern uint64 SizeOfUncompressedDP;
#endif


extern Channel rccontrol;                       // Channel for debugging information,
                                                // not displayed in the standard running mode.

extern Channel rclog;							// Channel for control and warning messages,
                                                // saved to the control log file when running as server
												// and displayed to a user when running from the console.

extern Channel rcdev;							// Channel for internal messages, saved to the file
												// For internal usage only

extern TableLockManager table_lock_manager;

extern RSI_Manager* rsi_manager;				// RS Index manager, constructed in RCBase constructors

class RCEngine;
extern RCEngine* rceng;

extern int BufferingLevel;

extern bool DefaultPushDown;

//extern bool Caching;
extern int CachingLevel;

extern bool use_charset;

extern uint sum_of_page_faults;

extern IBThreadStorage<ConnectionInfo> ConnectionInfoOnTLS;

int		MakeDirs(char const* aPath);

#endif

